/*
 * Created on Feb 13, 2006
 *
 */
package se.umu.jobsubmission.impl.informationfinder;

import org.globus.mds.glue.GLUECERPType;
import java.util.Calendar;

import org.apache.axis.message.MessageElement;
import org.globus.wsrf.encoding.ObjectDeserializer;

import org.apache.log4j.Logger;

/**
 * @author tordsson
 *
 * Dummy information converter for GT4. 
 * Resource information is already in glue format. 
 * We must however set resource information cache validity time
 * and return an CachedResourceInformation object. 
 *
 */
public class GT4InformationConverter implements InformationConverter {
	
	private static Logger logger = Logger.getLogger(GT4InformationConverter.class); 

	/**
	 * Pack glue info and timestamp into cache-entry
	 */
    public Object convertInformation(Object nativeFormat,
      		 ResourceInformationCache resourceInformationCache) { 
		
		GLUECERPType glueInfo = (GLUECERPType) nativeFormat; 
		Calendar validTo = null; 
		
		try { 
			MessageElement any[] = glueInfo.get_any(); 
			String s = (String) ObjectDeserializer.toObject(any[0], String.class); 
			long timeInMillis = new Long(s).longValue(); 
			validTo = Calendar.getInstance(); 
			validTo.setTimeInMillis(timeInMillis); 
		} catch (Exception e) {
			System.out.println("Error getting valid to time: " + e.getMessage()); 
			validTo = Calendar.getInstance(); 
		}
		
		CachedResourceInformation info = new CachedResourceInformation(validTo, 
				glueInfo); 
		
		return info; 
		
	}

}
