package se.umu.wsag.util; 

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;

import org.apache.log4j.Logger;
import org.globus.axis.util.Util;
import org.globus.wsrf.container.ServiceContainer; 

public class JobSubmissionUtils {
	
	private static Logger logger = Logger.getLogger(JobSubmissionUtils.class); 
	
	private static int PING_TIMEOUT = 2000; 
	
    static {
        Util.registerTransport(); 
    }

    public static boolean ping(String resourceHost) {
        // Both ServiceHost.getDefaultPort() and
        // ServiceURL.getDefaultPort() returns the port of current container,
        // So we use ServiceContainer.DEFAULT_SECURE_PORT instead...
        return ping(resourceHost, ServiceContainer.DEFAULT_SECURE_PORT); 
    }
    
    /**
	 * Really ugly way to test if container (or any other service) is running.
	 * Unless a socket can be opened, we assume that the service
	 * is not running.	 
	 * @param resourceHost
	 * @return
	 */
	public static boolean ping(String resourceHost, int port) {
		
		Socket socket = null; 
		try {
			InetSocketAddress address = new InetSocketAddress(resourceHost, 
					port);
			socket = new Socket(); 						
			socket.connect(address, JobSubmissionUtils.PING_TIMEOUT); 
			socket.close(); 
		} 
		catch (IOException e) {
			if(socket != null) {
				try {
					socket.close(); 
				} catch (Exception err) {}
			}				
			return false; 
		}
		
		return true; 
	}

}

 

